<template>
  <div>
    <!--内容-->
    <div class="layout-content-padding">
      <div class="layout-content-main">
        <Row>
          <!--查询-->
          <Col span="24" style="margin-top: 10px">
            <Form id="formId" v-show="searchOpen" :label-width="90" inline onsubmit="return false">
              <label class="label-sign"></label>
              <Form-item class="search-item" label="样品名称:">
                <Input v-model="formObj.name" @on-enter="_formSearch" name="name" placeholder="请输入样品名称" clearable/>
              </Form-item>
              <Form-item class="search-item" label="样品编号:">
                <Input v-model="formObj.code" @on-enter="_formSearch" name="aptitude" placeholder="请输入样品编号" clearable/>
              </Form-item>
              <Form-item class="search-btn">
                <Button @click="_formSearch" type="primary">搜索</Button>
              </Form-item>
            </Form>
          </Col>
          <!--操作-->
          <Col span="24">

            <btn-list :msg="btn" :open="searchOpen" :show-search-btn="true" @on-result-change="_btnClick"
                     class="contHide"></btn-list>
          </Col>
          <!--表格-->
          <Col span="24">
            <PTVXETable ref="pageTable" :table-height="tableHeight" :form-id="formId" :loading="true"
                        :get-page="getPage" :icon-msg="iconMsg" @on-result-change="_tableResultChange" select-data>
              <vxe-table-column
                v-for="item in pageColumns"
                :key="item.key"
                :field="item.key"
                :title="item.title"
                :min-width="item.width?item.width:200"
                :fixed="item.fixed?item.fixed:undefined" sortable>
                <template slot-scope="scope">


                  <span v-if="item.key==='type'">
                      <span v-if="scope.row[item.key]===0">
                          检定
                      </span>
                      <span v-else-if="scope.row[item.key]===1">
                          校准
                      </span>
                       <span v-else-if="scope.row[item.key]===2">
                          外观检查
                      </span>
                  </span>

                  <span v-else>{{scope.row[item.key]}}</span>
                </template>
              </vxe-table-column>
            </PTVXETable>
          </Col>
        </Row>
      </div>
    </div>
    <CertificateMake ref="itemOriginalRecordModal" @on-result-change="_resultRecord"></CertificateMake>
    <SelectOriTempRecord ref="SelectOriTempRecord" @on-result-change="_certificateSelectBack"></SelectOriTempRecord>
    <docimasy ref="docimasy" @on-result-change="_page"></docimasy>
    <FileManage ref="FileManage" @on-result-change="_page"></FileManage>
    <operationModal ref="operationModal" @on-result-change="_page"></operationModal>
    <SelEquip ref="SelEquip" @on-result-change="_equipSelectBack"></SelEquip>
    <CarManage ref="carEdit" @on-result-change="_page"></CarManage>
    <InstruMentEdit ref="InstruEdit" @on-result-change="_page"></InstruMentEdit>
    <MeterPersonItemTaskManage ref="personModal" @on-result-change="_page"></MeterPersonItemTaskManage>
    <MeterSubcontractorEdit ref="editSubcontractorModal" @on-result-change="_formSearch"></MeterSubcontractorEdit>
    <CertificateMakeLook ref="itemOriginalRecordLookModal" @on-result-change="_resultRecord"></CertificateMakeLook>

  </div>
</template>
<script>
import { meterDevice, meterSample } from '../../../api'
import CertificateMake from '../../meter-certificate/CertificateMake'
import SelEquip from '../../../components/select-equip/SelEquip'
import operationModal from '../../../components/operation/Operation'
import CertificateMakeLook from '../../meter-certificate/CertificateMakeLook'
import MeterSubcontractorEdit from './MeterGoOutTestEdit'
import CarManage from './CarManage'
import MeterPersonItemTaskManage from './MeterPersonItemTaskManage'
import InstruMentEdit from './InstrumentEdit'
import docimasy from './docimasy'
import SelectOriTempRecord from './SelectOriTempRecord'
export default {
  components: {
    CertificateMake,
    CertificateMakeLook,
    SelectOriTempRecord,
    docimasy,
    MeterSubcontractorEdit,
    CarManage,
    MeterPersonItemTaskManage,
    SelEquip,
    InstruMentEdit,
    operationModal
  },
  data() {
    return {
      currentComponent: '',
      formId: 'meterSubcontractorFormId',
      searchOpen: false,
      btn: [
        {
          type: 'success',
          id: 'personal-task-meter-out-personal-task-take',
          name: '仪器领用'
        },
        {
          type: 'success',
          id: 'personal-task-meter-out-personal-task-car',
          name: '车辆管理'
        },
        {
          type: 'success',
          id: 'personal-task-meter-out-personal-task-submit',
          name: '提交'
        },
        {
          type: 'success',
          id: 'personal-task-meter-out-personal-task-submit-create',
          name: '提交至证书编制'
        },
        {
          type: 'success',
          id: 'personal-task-meter-out-personal-task-condition',
          name: '检定条件'
        }
      ],
      iconMsg: [
        {
          type: 'ios-bookmarks',
          id: 'personal-task-meter-out-personal-task-create-operation',
          name: '编制证书'
        },
        {
          type: 'md-create',
          id: 'personal-task-meter-out-personal-task-result-operation',
          name: '检测结果'
        },
        {
          type: 'md-car',
          id: 'personal-task-meter-out-personal-task-car-operation',
          name: '车辆管理'
        },
        {
          type: 'ios-list-box',
          id: 'personal-task-meter-out-personal-task-take-operation',
          name: '仪器领用'
        },
        {
          type: 'md-cloud',
          id: 'personal-task-meter-out-personal-task-accessory-operation',
          name: '附件'
        },
        {
          type: 'ios-clock',
          id: 'personal-task-meter-out-personal-task-record-operation',
          name: '操作日志'
        }
      ],
      formObj: {
        name: undefined,
        code: undefined
      },
      selectIds: [],
      selectData: [],
      getPage: {},
      pageColumns: [
        { title: '样品名称', key: 'name', width: 120 },
        { title: '样品编号', key: 'code', width: 120 },
        { title: '证书是否编制', key: 'onlineReported', width: 120 },
        { title: '证书编号', key: 'reportCode', width: 130 },
        { title: '型号规格', key: 'spec', width: 120 },
        { title: '出厂编号', key: 'factoryNumber', width: 120 },
        { title: '检测类型', key: 'type', width: 100 },
        { title: '温度', key: 'temperature', width: 100 },
        { title: '湿度', key: 'humidity', width: 100 },
        { title: '地点', key: 'place', width: 100 },
        { title: '其他', key: 'cElse', width: 100 },
        { title: '委托单位', key: 'client', width: 200 },
        { title: '联系人', key: 'person', width: 120 },
        { title: '联系电话', key: 'tel', width: 120 },
        { title: '详细地址', key: 'address', width: 250 },
        { title: '数量', key: 'quantity' },
        { title: '备注', key: 'remark' }
      ]
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('search')
      } else {
        return this.$tableHeight('noSearch')
      }
    }
  },
  mounted() {
    this._page()
  },
  methods: {
    _btnClick(msg, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (msg) {
          case '检定条件':
            this._docimasy()
            break
          case '仪器领用':
            this._receiveApparatus()
            break
          case '车辆管理':
            this._carManage()
            break
          case '添加':
            this._editModal(false)
            break
          case '提交':
            this._submitToReportReview()
            break
          case '提交至证书编制':
            this._submitToReportMake()
            break
          case 'search':
            this.searchOpen = !this.searchOpen
            break
        }
      })
    },
    _docimasy() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请至少选择一条数据！')
      } else {
        this.$refs.docimasy._open(this.selectIds)
      }
    },
    _carManage() {
      this.$refs.carEdit._open()
    },
    _receiveApparatus() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请至少选择一条数据！')
      } else {
        this.$refs.SelEquip._open('sample-input')
      }
    },
    _submitToReportReview() {
      const ids = this.selectIds
      const data = this.selectData
      if (ids.length === 0) {
        this.$Message.warning('请至少选择一条数据！')
      } else {
        for (let i = 0; i < data.length; i++) {
          if (data[i].recordId === undefined) {
            this.$Message.warning(
              '您选择的样品编号为' + data[i].code + '暂未编制证书，无法提交！'
            )
            return false
          }
        }
        this.$Modal.confirm({
          title: '提示',
          content: '确定要把这 ' + ids.length + ' 条记录提交到证书核准？',
          onOk: () => {
            this._submitReportCheck(ids)
          }
        })
      }
    },
    _submitReportCheck: async function(ids) {
      const result = await meterSample.toReportCheck(ids)
      if (result) {
        await this._page()
        this.$Message.success('提交成功！')
      }
    },
    _submitToReportMake() {
      const ids = this.selectIds
      if (ids.length === 0) {
        this.$Message.warning('请至少选择一条数据！')
      } else {
        this.$Modal.confirm({
          title: '提示',
          content: '确定要把这 ' + ids.length + ' 条记录提交到证书编制？',
          onOk: () => {
            this._submitReportMake(ids)
          }
        })
      }
    },
    _submitReportMake: async function(ids) {
      const result = await meterSample.toReportMake(ids)
      if (result) {
        await this._page()
        this.$Message.success('提交成功！')
      }
    },
    _iconClick(res, data, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (res) {
          case '编制证书':
            this._makeCertificate(data)
            break
          case '仪器领用':
            this.$refs.InstruEdit._open(data.id)
            break
          case '车辆管理':
            this.$refs.carEdit._open()
            break
          case '检测结果':
            this._personModal(data)
            break
          case '资质项目':
            this._itemModal(data.id)
            break
          case '附件':
            this._upload(data.id)
            break
          case '删除':
            this._deleteByIds([data.id])
            break
          case '操作日志':
            this._record(data.id)
            break
        }
      })
    },
    _certificateSelectBack(data) {
      console.log('_certificateSelectBack', data)
      if (data) {
        this._makeCode(data)
      } else {
        const ids = this.selectIds
        if (ids.length === 0) {
          this.$Message.warning('请至少选择一条数据!')
        } else {
          // this._appendOriginalRecord()
        }
      }
    },

    _makeCode: async function(data) {
      const result = await meterSample.makeCode(data)
      if (result) {
        if (result === '' || result === undefined) {
          this.$Message.warning('证书编号暂未生成！')
          return false
        }
        data.dataSource.cc = result
        this.$refs.itemOriginalRecordModal._open(
          data.sampleId,
          data.tempId,
          data.dataSource
        )
      }
    },

    _makeCertificate(data) {
      if (data.onlineReported === '否' || undefined === data.recordId) {
        console.log('click')
        this.$refs.SelectOriTempRecord._open(data.id, data)
      } else {
        this._itemOriginalRecordLook(data, 'write')
      }
    },
    _itemOriginalRecordLook(data, name) {
      if (
        data.recordId === null ||
        undefined === data.recordId ||
        data.recordId === ''
      ) {
        this.$Message.warning('证书暂未编制！')
      } else {
        console.log('Original')
        this.$refs.itemOriginalRecordLookModal._open(
          data.recordId,
          name,
          data.id
        )
      }
    },
    _resultRecord() {
      this.$refs.SelectOriTempRecord.showModal = false
      this._page()
      this.$emit('on-result-change')
    },
    _personModal(data) {
      this.$refs.personModal._open(data.id)
    },
    _equipSelectBack(data) {
      console.log('_equipSelectBack', data)
      const equipData = []
      for (let i = 0; i < data.length; i++) {
        const object = data[i]
        const obj = {}
        obj.name = object.name
        obj.certificateNo = object.ceNum
        obj.measuringRange = object.range
        obj.uncertaintyAccuray = object.uncertainty
        obj.validUntil = object.effectDate
        equipData.push(obj)
      }
      this._addEquipUse({ sampleIds: this.selectIds, devicesList: equipData })
    },

    _addEquipUse: async function(data) {
      const result = await meterDevice.addEquipUse(data)
      if (result) {
        await this._page()
      }
    },

    _record(id) {
      this.$refs.operationModal._open(id)
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'iconClick':
          this._iconClick(data.name, data.rowData, data.componentName)
          break
        case 'selectData':
          this.selectData = data
          this.selectIds = []
          for (let i = 0; i < data.length; i++) {
            this.selectIds.push(data[i].id)
          }
          break
        case 'changeSize':
          this._page()
          break
      }
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      console.log('this.formObj', this.formObj)
      const result = await meterSample.pageOutPersonalTask(this.formObj)
      if (result) {
        this.$refs.pageTable._hideLoading()
        this.getPage = result
      }
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    // 删除
    _deleteByIds(ids, content) {
      this.$Modal.confirm({
        title: '提示',
        content: content || '确定删除该记录？',
        onOk: () => {
          this._delete(ids)
        }
      })
    },
    // 编辑&添加
    _editModal(edit, id) {
      if (edit) {
        // 编辑
        this._getById(id)
      } else {
        // 添加
        this.$refs.editSubcontractorModal._open()
      }
    },
    // 追加项目
    _itemModal(data) {
      this.$refs.refModal._open(data)
    },

    _upload(id) {
      // 上传文件
      this.$refs.FileManage._open(id, 'subcontractorId')
    },
    _getById: async function(id) {
      const result = await meterSample.getById(id)
      if (result) {
        this.$refs.editSubcontractorModal._openEdit(result)
      }
    },
    _delete: async function(ids) {
      const result = await meterSample.deleteById(ids)
      if (result) {
        this._formSearch()
        this.$Message.success('删除成功！')
      }
    }
  }
}
</script>
